
// 定数
// Sviqs 共通係数⓸
var gSviqsExtra = 100;
// Adv 共通係数⓹
var gAdvExtra = 101;

// シーン識別定数
var vbrScn_In_BuildingEntrance = 0;     // In-Building Entrance
var vbrScn_In_Corridor = 1;             // In-Corridor
var vbrScn_Out_BuildingEntrance = 2;    // O-Building Entrance
var vbrScn_Out_Sidewalk = 3;            // Out-Sidewalk
var vbrScn_Out_Carpark = 4;             // Out-Carpark
var vbrScn_Out_Carpark2 = 5;            // Out-Carpark2 
var vbrScn_Out_Intersection = 6;        // Out-Intersection 
var vbrScn_In_fisheye = 7;              // Indoor-fisheye
var vbrScn_In_fisheye_fisheye = 8;      // Indoor-fisheye_fisheye(直接指定はない)

// VBR SmartCoding 種別
var vbrSmartCoding_None = 0;
var vbrSmartCoding_SmartVIQS = 1;
var vbrSmartCoding_AUTOVIQS = 2;

// vbrCamInfTable のカメラ毎のリストの情報名
var vbrCamInfTable_CamId = 0;
var vbrCamInfTable_Enable = 1;
var vbrCamInfTable_SCType = 2;
var vbrCamInfTable_SceneList = 3;

// コーデック
var vbr_h265 = 0;
var vbr_h264 = 1;

// ips値リスト
var vbr_ips = [1,3,5,10,15,30,60];


// ★★★ここはExcelから自動生成にしたい★★★
// H.265Vbr カメラ種別番号
// VBR係数方式計算対応・非対応(以降のデータは対応の場合のみ参照)
// 対応SmartCoding
// 対応シーンリスト
var vbrCamInfTable = 
[
    // EXTREME 次世代 2M シリーズカメラ(S32302/S35302/X35302)
    [camKind_H265Vbr_EX_Next_2M_S, 1, vbrSmartCoding_AUTOVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代 4M シリーズカメラ(S32402/S35402/X35402)
    [camKind_H265Vbr_EX_Next_4M_S, 1, vbrSmartCoding_AUTOVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代PTZ 2M シリーズカメラ(S663**/X663**)
    [camKind_H265Vbr_EX_NextPTZ_2M_S, 1, vbrSmartCoding_SmartVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代PTZ 2M シリーズカメラ(S663**/X663**)
    [camKind_H265Vbr_EX_NextPTZ_2M_S, 1, vbrSmartCoding_SmartVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代PTZ 6M シリーズカメラ(S666**/X666**)
    [camKind_H265Vbr_EX_NextPTZ_6M_S, 1, vbrSmartCoding_SmartVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代PTZ 4K シリーズカメラ(S667**/X667**)
    [camKind_H265Vbr_EX_NextPTZ_4K_S, 1, vbrSmartCoding_SmartVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代 2M シリーズカメラ(U313**/U353**)
    [camKind_H265Vbr_EX_Next_2M_U, 1, vbrSmartCoding_AUTOVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代 4M シリーズカメラ(U314**/U354**)
    [camKind_H265Vbr_EX_Next_4M_U, 1, vbrSmartCoding_AUTOVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代 2M Xシリーズカメラ(X153**/X223**/X253**)
    [camKind_H265Vbr_EX_Next_2M_X, 1, vbrSmartCoding_SmartVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代 5M Xシリーズカメラ(X155**/X225**/X2550*)
    [camKind_H265Vbr_EX_Next_5M_X, 1, vbrSmartCoding_SmartVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代 6M Xシリーズカメラ(X156**/X226**/X256**)
    [camKind_H265Vbr_EX_Next_6M_X, 1, vbrSmartCoding_SmartVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME 次世代 4K Xシリーズカメラ(X157**/X227**/X257**)
    [camKind_H265Vbr_EX_Next_4K_X, 1, vbrSmartCoding_SmartVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // EXTREME マイク付きUシリーズカメラ(U21300/U11300)
    [camKind_H265Vbr_EX_MIC_U, 0, vbrSmartCoding_AUTOVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // Extreme 次世代PT Sシリーズカメラ(B51300/B54300)
    [camKind_H265Vbr_NextPT_S, 0, vbrSmartCoding_AUTOVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // Extreme 次世代PTZ Sシリーズカメラ(S61300/S65300/S65301/S65302)
    [camKind_H265Vbr_NextPTZ_S, 0, vbrSmartCoding_SmartVIQS, [vbrScn_In_BuildingEntrance, vbrScn_In_Corridor, vbrScn_Out_BuildingEntrance, vbrScn_Out_Sidewalk, vbrScn_Out_Carpark]],

    // Extreme 次世代 5M PTZ Sシリーズカメラ(S61501/S65501)
    [camKind_H265Vbr_Next5MPTZ_S, 0, vbrSmartCoding_None, []],

    // Extreme 次世代2眼マルチセンサーカメラ(S85402)
    [camKind_H265Vbr_EX_AIMS, 0, vbrSmartCoding_None, []],

    // Extreme 次世代2眼マルチセンサーカメラ(S85702)
    [camKind_H265Vbr_EX_AIMS_4K, 0, vbrSmartCoding_None, []],

    // Extreme 次世代2眼マルチセンサーカメラ(U85402)
    [camKind_H265Vbr_EX_AIMS_U, 0, vbrSmartCoding_None, []],

    // Extreme 次世代PTZマルチセンサー一体型カメラ(X86530/X86531)
    [camKind_H265Vbr_EX_AIMS_X, 0, vbrSmartCoding_None, []],

    // Extreme 次世代PTZマルチセンサー一体型カメラPTZ(X86530/X86531)
    [camKind_H265Vbr_EX_AIMS_X_PTZ, 0, vbrSmartCoding_None, []],

    // Extreme 次世代PTZ Uシリーズカメラ
    [camKind_H265Vbr_NextPTZ_U, 0, vbrSmartCoding_None, []],

    // EXTREME 4K固定カメラ
    [camKind_H265Vbr_EX_4K_5M6M, 0, vbrSmartCoding_None, []],

    // EXTREME i-PRO mini AI 固定カメラ
    [camKind_H265Vbr_EX_IPROMINI, 0, vbrSmartCoding_None, []],

    // Extremeカメラ
    [camKind_H265Vbr_NextS, 0, vbrSmartCoding_None, []],

    // H.265(1)カメラ(1)
    [camKind_H265Vbr_01, 0, vbrSmartCoding_None, []],

    // H.265(1)カメラ(2)
    [camKind_H265Vbr_02, 0, vbrSmartCoding_None, []],

    // H.265(1)カメラ(3)
    [camKind_H265Vbr_03, 0, vbrSmartCoding_None, []],

    // EXTREME 4Kカメラ
    [camKind_H265Vbr_EX_4K, 0, vbrSmartCoding_None, []],

    // EXTREME AI全方位カメラ
    [camKind_H265Vbr_EX_AI360, 0, vbrSmartCoding_AUTOVIQS, [vbrScn_In_fisheye]],
    
    // EXTREME 全方位カメラ
    [camKind_H265Vbr_EX_9M, 0, vbrSmartCoding_None, []],
    
    // EXTREME AIマルチセンサーカメラ 30ips S854* 
    [camKind_H265Vbr_EX_AIMS_30ips, 0, vbrSmartCoding_None, []],
    
    // EXTREME AIマルチセンサーカメラ 15ips S856*/S857*
    [camKind_H265Vbr_EX_AIMS_15ips, 0, vbrSmartCoding_None, []],
    
    // EXTREME マルチセンサーカメラ
    [camKind_H265Vbr_EX_MS, 0, vbrSmartCoding_None, []],
    
    // EXTREME Uシリーズカメラ
    [camKind_H265Vbr_EX_U, 0, vbrSmartCoding_None, []],
    
    // EXTREME AIカメラ
    [camKind_H265Vbr_EX_AI, 0, vbrSmartCoding_None, []],

    // EXTREME AI 4Kカメラ
    [camKind_H265Vbr_EX_AI_4K, 0, vbrSmartCoding_None, []]
];



// Type
VBRCoefficient = function(ref, sviqs, adv) {
    this.ref = ref;
    this.sviqs = sviqs;
    this.adv = adv;
};

// VBR 係数リスト
var VBRCoefList = [                                             // GOP制御/SmartVIQS/物体
    new VBRCoefficient(1, 1, 1),                        	// OFF/OFF/なし
    new VBRCoefficient(1, 1, 1),                        	// OFF/OFF/あり
    new VBRCoefficient(8, 1, 1),                        	// Low/OFF/なし
    new VBRCoefficient(1, 1, 1),                        	// Low/OFF/あり
    new VBRCoefficient(6, 1, 1),                        	// Mid/OFF/なし
    new VBRCoefficient(4, 1, 1),                        	// Mid/OFF/あり
    new VBRCoefficient(1, 1, gAdvExtra),                	// Adv/OFF/なし
    new VBRCoefficient(1, 1, gAdvExtra),              	    // Adv/OFF/あり
    new VBRCoefficient(1, gSviqsExtra, 1),              	// OFF/High/なし
    new VBRCoefficient(1, gSviqsExtra, 1),              	// OFF/High/あり
    new VBRCoefficient(8, gSviqsExtra, 1),              	// Low/High/なし
    new VBRCoefficient(1, gSviqsExtra, 1),              	// Low/High/あり
    new VBRCoefficient(6, gSviqsExtra, 1),              	// Mid/High/なし
    new VBRCoefficient(4, gSviqsExtra, 1),              	// Mid/High/あり
    new VBRCoefficient(1, gSviqsExtra, gAdvExtra),    	    // Adv/High/なし
    new VBRCoefficient(1, gSviqsExtra, gAdvExtra),    	    // Adv/High/あり
    new VBRCoefficient(1, gSviqsExtra, 1),              	// OFF/Low/なし
    new VBRCoefficient(1, gSviqsExtra, 1),              	// OFF/Low/あり
    new VBRCoefficient(8, gSviqsExtra, 1),              	// Low/Low/なし
    new VBRCoefficient(1, gSviqsExtra, 1),              	// Low/Low/あり
    new VBRCoefficient(6, gSviqsExtra, 1),              	// Mid/Low/なし
    new VBRCoefficient(4, gSviqsExtra, 1),              	// Mid/Low/あり
    new VBRCoefficient(1, gSviqsExtra, gAdvExtra),        	// Adv/Low/なし
    new VBRCoefficient(1, gSviqsExtra, gAdvExtra)     	    // Adv/Low/あり
];

// ②30fpsに対する他フレームレートのPpic符号量の割合(共通)
var vbr_ppicrate_for_30fps =
[
    // fps 1, 3, 5, 10, 15, 30, 60
    [0, 2.7, 2.2, 1.7, 1.4, 1, 0.7],        // 1s
    [2.7, 2.7, 2.2, 1.7, 1.4, 1, 0.7]       // 1s超
];

// ④SmartVIQS用係数
var vbr_coefficient_SVIQS =
[
    // fps 1, 3, 5, 10, 15, 30, 60
    [0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5],    // 物体なし
    [0.74, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9]    // 物体あり
];

// ⑤OFFに対するAdvanced用係数
var vbr_coefficient_Adv =
[
    [   // 通常照度/低照度・物体なし
        // fps 1, 3, 5, 10, 15, 30, 60
        [0.48, 0.48, 0.48, 0.48, 0.48, 0.48, 0.48],     // 画質1
        [0.37, 0.37, 0.37, 0.37, 0.37, 0.37, 0.37],     // 画質3
        [0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3],            // 画質5
        [0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3],            // 画質7
        [0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3]             // 画質9
    ],
    [   // 通常照度/低照度・物体あり
        // fps 1, 3, 5, 10, 15, 30, 60
        [0.55, 0.55, 0.55, 0.69, 0.69, 0.86, 0.86],     // 画質1
        [0.51, 0.51, 0.51, 0.64, 0.64, 0.82, 0.82],     // 画質3
        [0.47, 0.47, 0.47, 0.57, 0.57, 0.76, 0.76],     // 画質5
        [0.43, 0.43, 0.43, 0.50, 0.50, 0.70, 0.70],     // 画質7
        [0.43, 0.43, 0.43, 0.53, 0.53, 0.75, 0.75]      // 画質9
    ]
];

// 1080p の符号量
var VBRBitrate = function(stil_norm_ipic, stil_norm_ppic, move_norm_ipic, move_norm_ppic, stil_low_ipic, stil_low_ppic, move_low_ipic, move_low_ppic) {
    this.stil_norm_ipic = stil_norm_ipic;
    this.stil_norm_ppic = stil_norm_ppic;
    this.move_norm_ipic = move_norm_ipic;
    this.move_norm_ppic = move_norm_ppic;

    this.stil_low_ipic = stil_low_ipic;
    this.stil_low_ppic = stil_low_ppic;
    this.move_low_ipic = move_low_ipic;
    this.move_low_ppic = move_low_ppic;
};

// H.264(AI)
var vbr_bitratelist_h264 = [
    // In-Building Entrance
    [
        [   // 通常用
            new VBRBitrate(1683575, 79023, 1887032, 186414, 2732525, 524548, 2726730, 522916),  // 画質1
            new VBRBitrate(1154887, 27002, 1175383, 92449, 2445317, 243429, 2442987, 362171),   // 画質3
            new VBRBitrate(1105362, 14402, 1123926, 72870, 1358201, 75616, 1361836, 108279),    // 画質5
            new VBRBitrate(804509, 13555, 821957, 54659, 836739, 35577, 842739, 48692),         // 画質7
            new VBRBitrate(488947, 12646, 501944, 40825, 563112, 17444, 569546, 25930)          // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(2357005, 110633, 3533897, 354186, 3005777, 577003, 2999403, 575208), // 画質1
            new VBRBitrate(1270375, 29702, 1616152, 120183, 2689849, 267772, 2687285, 398388),  // 画質3
            new VBRBitrate(1215898, 15842, 1236319, 80156, 1494021, 83178, 1498020, 119107),    // 画質5
            new VBRBitrate(884959, 14910, 904153, 60125, 920413, 39135, 927013, 53562),         // 画質7
            new VBRBitrate(537841, 13911, 552139, 44907, 619423, 19189, 626500, 28523)          // 画質9
        ]
    ],
    // In-Corridor
    [
        [   // 通常用
            new VBRBitrate(2035863, 89159, 2089236, 204346, 1862577, 242825, 1914230, 310299),  // 画質1
            new VBRBitrate(1400256, 30645, 1481472, 117571, 1513980, 88998, 1588929, 150907),   // 画質3
            new VBRBitrate(907065, 10391, 973634, 71163, 808146, 19086, 849902, 61150),         // 画質5
            new VBRBitrate(613539, 5812, 667165, 51659, 496799, 7693, 526493, 37081),           // 画質7
            new VBRBitrate(249926, 2063, 272418, 21390, 340963, 5677, 367798, 27828)            // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(2443035, 106991, 3729286, 337170, 2235092, 291390, 2297076, 372359), // 画質1
            new VBRBitrate(1680307, 36774, 1777766, 141085, 1816776, 106798, 1906714, 181089),  // 画質3
            new VBRBitrate(1088478, 12469, 1168361, 85395, 969775, 22903, 1019882, 73380),      // 画質5
            new VBRBitrate(736247, 6975, 800597, 61991, 596159, 9232, 631792, 44498),           // 画質7
            new VBRBitrate(299911, 2475, 326901, 25668, 409155, 6813, 441357, 33394)            // 画質9
        ]
    ],
    // O-Building Entrance
    [
        [   // 通常用
            new VBRBitrate(1945409, 116572, 2779078, 255861, 2677486, 420495, 2671680, 461999), // 画質1
            new VBRBitrate(1486136, 47818, 1610142, 118526, 1779430, 281176, 1807248, 326443),  // 画質3
            new VBRBitrate(1049254, 19841, 1145359, 68262, 1139964, 107562, 1161096, 141917),   // 画質5
            new VBRBitrate(776308, 15595, 857169, 51891, 745111, 48824, 760793, 75083),         // 画質7
            new VBRBitrate(496350, 15333, 551890, 40425, 700704, 20174, 701228, 35458)          // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(3705542, 222042, 5161145, 481018, 5065278, 651767, 5076192, 739198), // 画質1
            new VBRBitrate(1931977, 62164, 2495720, 171862, 2580173, 365528, 2575329, 424376),  // 画質3
            new VBRBitrate(1364030, 25794, 1488966, 88741, 1481953, 139830, 1509425, 184492),   // 画質5
            new VBRBitrate(1009201, 19308, 1114319, 67458, 968644, 63471, 989031, 97608),       // 画質7
            new VBRBitrate(645255, 19856, 717458, 52552, 808504, 38797, 811224, 46095)          // 画質9
        ]
    ],
    // Out-Sidewalk
    [
        [   // 通常用
            new VBRBitrate(6597714, 340127, 6620067, 426717, 4065984, 500116, 4047349, 588113), // 画質1
            new VBRBitrate(4863432, 132374, 4895428, 193877, 3138894, 253684, 3177193, 333255), // 画質3
            new VBRBitrate(3449343, 59390, 3483555, 100355, 1893564, 90675, 1906187, 139489),   // 画質5
            new VBRBitrate(2489769, 39843, 2523200, 71739, 1160331, 46039, 1173044, 81109),     // 画質7
            new VBRBitrate(1422508, 21133, 1449228, 40740, 750826, 23431, 761801, 49566)        // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(6597714, 340127, 7944081, 469389, 4148963, 500116, 4249717, 588113), // 画質1
            new VBRBitrate(4863432, 132374, 4895428, 193877, 3138894, 253684, 3177193, 333255), // 画質3
            new VBRBitrate(3449343, 59390, 3483555, 100355, 1893564, 90675, 1906187, 139489),   // 画質5
            new VBRBitrate(2489769, 39843, 2523200, 71739, 1160331, 46039, 1173044, 81109),     // 画質7
            new VBRBitrate(1422508, 21133, 1449228, 40740, 750826, 23431, 761801, 49566)        // 画質9
        ]
    ],
    // Out-Carpark
    [
        [   // 通常用
            new VBRBitrate(3315649, 192983, 3489803, 265075, 2599257, 305258, 2595146, 727558), // 画質1
            new VBRBitrate(2774513, 89179, 2784255, 136553, 2498304, 218335, 2491262, 473167),  // 画質3
            new VBRBitrate(2000154, 33346, 2009298, 65769, 1647363, 107488, 1660587, 244631),   // 画質5
            new VBRBitrate(1233719, 15628, 1241029, 36642, 1125076, 65677, 1132178, 157713),    // 画質7
            new VBRBitrate(913695, 10077, 923177, 26366, 792942, 38593, 834021, 102255)         // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(5139257, 299124, 6647244, 504906, 4404296, 473150, 4411749, 1091336),// 画質1
            new VBRBitrate(4161769, 133769, 4176382, 204830, 4051304, 327503, 4048300, 709751), // 画質3
            new VBRBitrate(3000231, 50019, 3013947, 98654, 2601099, 161232, 2615424, 366947),   // 画質5
            new VBRBitrate(1850578, 23442, 1861543, 54963, 1687614, 98516, 1698266, 236569),    // 画質7
            new VBRBitrate(1370543, 15116, 1384766, 39550, 1189413, 57890, 1251031, 153383)     // 画質9
        ]
    ],
    // Out-Carpark2 
    [
        [   // 通常用
            new VBRBitrate(6520884, 20026, 6932180, 30958, 2178458, 39902, 2178458, 47388),     // 画質1
            new VBRBitrate(3989214, 9676, 4307946, 13860, 1092772, 8916, 1256464, 20084),       // 画質3
            new VBRBitrate(3444216, 6750, 3716372, 11246, 923158, 5970, 1053856, 14082),        // 画質5
            new VBRBitrate(2500188, 6750, 2705022, 8964, 648950, 5136, 738708, 8946),           // 画質7
            new VBRBitrate(1252890, 6644, 1272060, 7760, 386892, 5090, 393654, 7900)            // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(7499017, 23030, 7702422, 35602, 2723073, 51873, 2723073, 56866),     // 画質1
            new VBRBitrate(4587596, 11127, 4954138, 15939, 1256688, 10253, 1444934, 23097),     // 画質3
            new VBRBitrate(3960848, 7763, 4273828, 12933, 1061632, 6866, 1211934, 16194),       // 画質5
            new VBRBitrate(2875216, 7763, 3110775, 10309, 746293, 5906, 849514, 10288),         // 画質7
            new VBRBitrate(1440824, 7641, 1462869, 8924, 444926, 5854, 452702, 9085)            // 画質9
        ]
    ],
    // Out-Intersection 
    [
        [   // 通常用
            new VBRBitrate(5713236, 42004, 11877113, 92404, 2869409, 98264, 4363893, 221121),   // 画質1
            new VBRBitrate(3279556, 18942, 4967529, 29937, 1351102, 21094, 2183004, 89547),     // 画質3
            new VBRBitrate(2831508, 13221, 4285380, 24294, 1141394, 14713, 1664534, 57078),     // 画質5
            new VBRBitrate(2055416, 13212, 3119184, 19434, 802366, 9103, 1000089, 31077),       // 画質7
            new VBRBitrate(921806, 12483, 1683502, 22656, 375504, 9013, 469380, 25143)          // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(7712869, 28712, 9444452, 73478, 2749850, 113004, 2749850, 151453),   // 画質1
            new VBRBitrate(3771489, 14522, 3808439, 22952, 1294806, 21094, 1304132, 58148),     // 画質3
            new VBRBitrate(3256234, 10136, 3285458, 18625, 1093836, 13536, 1093836, 37508),     // 画質5
            new VBRBitrate(2363728, 10129, 2391374, 14899, 768934, 8374, 766735, 23826),        // 画質7
            new VBRBitrate(1060077, 9570, 1090720, 14888, 359858, 8292, 359858, 19276)          // 画質9
        ]
    ],
    // Indoor-fisheye
    [
        [   // 通常用
            new VBRBitrate(6887444, 52769, 6887444, 130372, 5852942, 374060, 6037580, 432942),  // 画質1
            new VBRBitrate(4254726, 26735, 4356029, 56872, 2740912, 54073, 2870570, 76280),     // 画質3
            new VBRBitrate(3638964, 17955, 3725606, 47113, 2257712, 34877, 2390338, 53821),     // 画質5
            new VBRBitrate(2641006, 16874, 2703887, 35987, 1583702, 16472, 1657559, 30519),     // 画質7
            new VBRBitrate(1519283, 16674, 1589242, 36023, 614712, 11220, 670811, 19406)        // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(12462993, 97999, 12430196, 232808, 8082634, 516560, 8337610, 597873),// 画質1
            new VBRBitrate(5875574, 36920, 5875574, 74968, 3785068, 74672, 3964120, 105340),    // 画質3
            new VBRBitrate(5025236, 24795, 5025236, 63548, 3117793, 48163, 3300942, 74324),     // 画質5
            new VBRBitrate(3647104, 23302, 3647104, 48540, 2187018, 22748, 2289011, 42146),     // 画質7
            new VBRBitrate(2098057, 23026, 2194668, 49747, 848888, 15495, 926359, 26799)        // 画質9
        ]
    ],
    // Indoor-fisheye_fisheye
    [
        [   // 通常用
            new VBRBitrate(8366855, 45161, 8746500, 97289, 8317010, 572842, 10782415, 636140),  // 画質1
            new VBRBitrate(5282466, 15195, 5586414, 40559, 4346360, 87052, 6033976, 139807),    // 画質3
            new VBRBitrate(4551143, 13056, 4796768, 30726, 3534868, 51732, 4806941, 84809),     // 画質5
            new VBRBitrate(3270743, 10508, 3448785, 21932, 2415980, 29476, 3218953, 47425),     // 画質7
            new VBRBitrate(2016071, 10028, 2068755, 20664, 1098490, 12924, 1504428, 21678)      // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(8366855, 45161, 8746500, 97289, 8317010, 572842, 10782415, 636140),  // 画質1
            new VBRBitrate(5282466, 15195, 5586414, 40559, 4346360, 87052, 6033976, 139807),    // 画質3
            new VBRBitrate(4551143, 13056, 4796768, 30726, 3534868, 51732, 4806941, 84809),     // 画質5
            new VBRBitrate(3270743, 10508, 3448785, 21932, 2415980, 29476, 3218953, 47425),     // 画質7
            new VBRBitrate(2016071, 10028, 2068755, 20664, 1098490, 12924, 1504428, 21678)      // 画質9
        ]
    ]
];

// H.265(AI)
var vbr_bitratelist_h265 = [
    // In-Building Entrance
    [
        [   // 通常用
            new VBRBitrate(1431039, 67170, 1811551, 180821, 1994743, 382920, 1990513, 381729),  // 画質1
            new VBRBitrate(923909, 21601, 1034337, 81355, 1760629, 175269, 1758950, 260763),    // 画質3
            new VBRBitrate(884290, 11521, 910380, 59024, 950741, 52931, 953285, 75796),         // 画質5
            new VBRBitrate(603381, 10166, 624687, 41541, 568982, 24193, 573063, 33111),         // 画質7
            new VBRBitrate(391157, 10117, 351361, 28577, 371654, 11513, 375900, 17114)          // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(2357005, 106207, 3357202, 347102, 2194217, 421212, 2189564, 419902), // 画質1
            new VBRBitrate(1054411, 23761, 1454537, 114174, 1936691, 192796, 1934845, 286840),  // 画質3
            new VBRBitrate(972719, 12674, 1001418, 64927, 1045815, 58224, 1048614, 83375),      // 画質5
            new VBRBitrate(663720, 11182, 687156, 45695, 625881, 26612, 630369, 36422),         // 画質7
            new VBRBitrate(430273, 11129, 386497, 31435, 408819, 12665, 413490, 18825)          // 画質9
        ]
    ],
    // In-Corridor
    [
        [   // 通常用
            new VBRBitrate(1730483, 75785, 1984774, 194128, 1359681, 177262, 1397388, 226518),  // 画質1
            new VBRBitrate(1120205, 24516, 1303695, 103462, 1090066, 64079, 1144029, 108653),   // 画質3
            new VBRBitrate(725652, 8312, 788643, 57642, 565702, 13360, 594931, 42805),          // 画質5
            new VBRBitrate(460154, 4359, 507045, 39261, 337823, 5232, 358016, 25215),           // 画質7
            new VBRBitrate(199941, 1650, 190692, 14973, 225035, 3747, 242747, 18367)            // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(2418605, 101641, 3617407, 327055, 1631617, 212715, 1952515, 297887), // 画質1
            new VBRBitrate(1344246, 29419, 1582212, 126976, 1308079, 76894, 1372834, 130384),   // 画質3
            new VBRBitrate(870782, 9975, 946372, 69170, 678843, 16032, 713918, 51366),          // 画質5
            new VBRBitrate(552185, 5231, 608454, 47113, 405388, 6278, 429619, 30258),           // 画質7
            new VBRBitrate(239929, 1980, 228831, 17967, 278225, 4496, 308950, 23376)            // 画質9
        ]
    ],
    // O-Building Entrance
    [
        [   // 通常用
            new VBRBitrate(1933737, 111326, 2640124, 245370, 1954565, 306961, 1958341, 337259), // 画質1
            new VBRBitrate(1188909, 38255, 1416925, 104303, 1281190, 202446, 1301219, 235039),  // 画質3
            new VBRBitrate(839403, 15873, 927741, 55292, 797975, 75293, 812767, 99342),         // 画質5
            new VBRBitrate(582231, 12008, 651448, 39437, 506676, 33200, 517339, 51056),         // 画質7
            new VBRBitrate(397080, 12266, 386323, 28297, 462464, 13315, 462810, 23402)          // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(3705542, 213160, 4954699, 471398, 3697653, 475790, 3756382, 547007), // 画質1
            new VBRBitrate(1661500, 53461, 2296062, 163269, 1857725, 263180, 1854237, 305551),  // 画質3
            new VBRBitrate(1091224, 20635, 1206063, 71880, 1037367, 97881, 1056597, 129144),    // 画質5
            new VBRBitrate(756900, 16895, 846883, 51268, 658678, 43160, 672541, 66373),         // 画質7
            new VBRBitrate(516204, 15885, 502220, 36787, 533613, 25606, 535408, 30423)          // 画質9
        ]
    ],
    // Out-Sidewalk
    [
        [   // 通常用
            new VBRBitrate(5608057, 289108, 6289064, 405381, 2968168, 365084, 2954565, 429323), // 画質1
            new VBRBitrate(3890746, 105899, 4307976, 170612, 2260004, 182652, 2287579, 239943), // 画質3
            new VBRBitrate(2759474, 47512, 2821680, 81288, 1325495, 63473, 1334331, 97643),     // 画質5
            new VBRBitrate(1867327, 29882, 1917632, 54522, 789025, 31307, 797670, 55154),       // 画質7
            new VBRBitrate(1138006, 16907, 1014460, 28518, 495545, 15465, 502789, 32714)        // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(5871965, 289108, 7546877, 455307, 3485129, 405094, 3867242, 529302), // 画質1
            new VBRBitrate(3890746, 105899, 4307976, 170612, 2260004, 182652, 2287579, 239943), // 画質3
            new VBRBitrate(2759474, 47512, 2821680, 81288, 1325495, 63473, 1334331, 97643),     // 画質5
            new VBRBitrate(1867327, 29882, 1917632, 54522, 789025, 31307, 797670, 55154),       // 画質7
            new VBRBitrate(1138006, 16907, 1014460, 28518, 495545, 15465, 502789, 32962)        // 画質9
        ]
    ],
    // Out-Carpark
    [
        [   // 通常用
            new VBRBitrate(2818302, 164036, 3315313, 251822, 2183376, 222838, 1894457, 531117), // 画質1
            new VBRBitrate(2219610, 71343, 2450144, 120167, 1798779, 157201, 1793708, 340680),  // 画質3
            new VBRBitrate(1600123, 26677, 1627531, 53273, 1153154, 75242, 1162411, 171242),    // 画質5
            new VBRBitrate(925289, 11721, 943182, 27848, 765052, 44661, 769881, 107245),        // 画質7
            new VBRBitrate(730956, 8062, 646224, 18456, 523342, 25471, 550454, 67489)           // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(5087864, 284168, 6314882, 479660, 4184082, 416372, 3220577, 829416), // 画質1
            new VBRBitrate(3329415, 107015, 3675216, 180250, 2916939, 235802, 2914776, 511021), // 画質3
            new VBRBitrate(2400185, 40015, 2441297, 79910, 1820770, 112862, 1830797, 256863),   // 画質5
            new VBRBitrate(1387934, 17582, 1414773, 41772, 1147578, 66991, 1154821, 160867),    // 画質7
            new VBRBitrate(1096434, 12093, 969336, 27685, 785013, 38207, 825680, 101233)        // 画質9
        ]
    ],
    // Out-Carpark2 
    [
        [   // 通常用
            new VBRBitrate(5542751, 17022, 6585571, 29410, 1590274, 29128, 1590274, 34593),     // 画質1
            new VBRBitrate(3191371, 7741, 3790992, 12197, 786796, 6420, 904654, 14460),         // 画質3
            new VBRBitrate(2755373, 5400, 3010261, 9109, 646211, 4179, 737699, 9857),           // 画質5
            new VBRBitrate(1875141, 5063, 2055817, 6813, 441286, 3492, 502321, 6083),           // 画質7
            new VBRBitrate(1002312, 5315, 890442, 5432, 255349, 3359, 259812, 5214)             // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(6374164, 19575, 7317301, 33822, 1987843, 37867, 1987843, 41512),     // 画質1
            new VBRBitrate(3670077, 8902, 4359641, 14026, 904815, 7382, 1040352, 16630),        // 画質3
            new VBRBitrate(3168679, 6210, 3461801, 10476, 743142, 4806, 848354, 11336),         // 画質5
            new VBRBitrate(2156412, 5822, 2364189, 7835, 507479, 4016, 577670, 6996),           // 画質7
            new VBRBitrate(1152659, 6112, 1024008, 6247, 293651, 3863, 298783, 5996)            // 画質9
        ]
    ],
    // Out-Intersection 
    [
        [   // 通常用
            new VBRBitrate(4856251, 35704, 11283258, 87784, 2094668, 71733, 3185642, 161418),   // 画質1
            new VBRBitrate(2623645, 15154, 4371426, 26345, 972793, 15187, 1571763, 64474),      // 画質3
            new VBRBitrate(2265206, 10577, 3471158, 19678, 798976, 10299, 1165173, 39955),      // 画質5
            new VBRBitrate(1541562, 9909, 2370580, 14770, 545609, 6190, 680061, 21132),         // 画質7
            new VBRBitrate(737445, 9986, 1178452, 15859, 247833, 5948, 309791, 16594)           // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(6555938, 24405, 8972229, 69804, 2007391, 82493, 2007391, 110560),    // 画質1
            new VBRBitrate(3017192, 11618, 3351426, 20197, 932260, 15187, 938975, 41866),       // 画質3
            new VBRBitrate(2604987, 8109, 2661221, 15087, 765685, 9475, 765685, 26256),         // 画質5
            new VBRBitrate(1772796, 7597, 1817445, 11324, 522875, 5695, 521380, 16201),         // 画質7
            new VBRBitrate(848062, 7656, 763504, 10422, 237506, 5472, 244703, 13686)            // 画質9
        ]
    ],
    // Indoor-fisheye
    [
        [   // 通常用
            new VBRBitrate(5923201, 45909, 6543071, 123854, 4272647, 273064, 4407433, 316048),  // 画質1
            new VBRBitrate(3403781, 21388, 3833306, 50048, 1973456, 38932, 2066810, 54922),     // 画質3
            new VBRBitrate(2911171, 14364, 3017741, 38161, 1580398, 24414, 1673236, 37675),     // 画質5
            new VBRBitrate(1980755, 12655, 2054954, 27350, 1076918, 11201, 1127140, 20753),     // 画質7
            new VBRBitrate(1215426, 13339, 1112470, 25216, 485622, 8864, 469568, 13584)         // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(11216694, 88199, 12181592, 228151, 5900322, 377089, 6086455, 436447),// 画質1
            new VBRBitrate(4700459, 29536, 5405528, 69720, 2725249, 53764, 2854167, 75845),     // 画質3
            new VBRBitrate(4020189, 19836, 4170946, 53380, 2182455, 33714, 2310660, 52027),     // 画質5
            new VBRBitrate(2735328, 17476, 2844741, 37376, 1487172, 15468, 1556527, 28659),     // 画質7
            new VBRBitrate(1678446, 18421, 1536267, 34823, 585733, 10691, 611397, 17687)        // 画質9
        ]
    ],
    // Indoor-fisheye_fisheye
    [
        [   // 通常用
            new VBRBitrate(7111826, 38386, 8309175, 92424, 6071417, 418175, 7871163, 464382),   // 画質1
            new VBRBitrate(4225973, 12156, 4916044, 35691, 3129379, 62677, 4344463, 100661),    // 画質3
            new VBRBitrate(3640914, 10445, 3885382, 24888, 2474408, 36212, 3364859, 59366),     // 画質5
            new VBRBitrate(2453057, 7881, 2621077, 16668, 1642866, 20044, 2188888, 32249),      // 画質7
            new VBRBitrate(1612856, 8022, 1448129, 14465, 725003, 8530, 992922, 14307)          // 画質9
        ],
        [   // 低解像度（640ｘ360、640ｘ480、800ｘ600）用
            new VBRBitrate(7697506, 42451, 8659035, 96316, 6071417, 418175, 7871163, 464382),   // 画質1
            new VBRBitrate(4225973, 12156, 4916044, 35691, 3129379, 62677, 4344463, 100661),    // 画質3
            new VBRBitrate(3640914, 10445, 3885382, 24888, 2474408, 36212, 3364859, 59366),     // 画質5
            new VBRBitrate(2453057, 7881, 2621077, 16668, 1642866, 20044, 2188888, 32249),      // 画質7
            new VBRBitrate(1612856, 8022, 1448129, 14465, 725003, 8530, 992922, 14307)          // 画質9
        ]
    ]
];

